---
title: "Advanced Topics"
linkTitle: "Advanced Topics"
weight: 35
hide_summary: true
no_list: true
---

## Advanced Topics
Kopia enables fast and secure snapshots of your data. It comprises compression, deduplication, and encrypted backups streamlined into a cross-platform application. 

In the following, we will highlight and explain some advanced topics related to Kopia. 

* [Architectural Design](architecture/#architecture)
* [Storage Classes](storage-tiers/#storage-classes)
* [Encryption](encryption/#encryption)
* [Compression](compression/#compression)
* [Error Correction Algorithm: Reed-Solomon](ecc/#error-correction-algorithm)
* [Maintenance](maintenance/#maintenance)
* [Consistency](consistency/#consistency)
	* [Verifying Validity of Snapshots](consistency/#verifying-validity-of-snapshots)
	* [Repairing Corruption of Snapshots](consistency/#repairing-corruption-of-snapshots)
* [Ignoring Files and Folders in Snapshots](kopiaignore/#ignoring-files-and-folders-in-snapshots)
* [Actions](actions/#actions)
* [Caching](caching/#caching)
* [Ransomware Protection](ransomware-protection/#what-is-ransomware-and-why-do-we-need-extra-protections)
* [Synchronization](synchronization/#synchronization)
* [Sharding](sharding/#sharding)
* [Logging](logging/#logging)
* [Compatibility among Kopia Versions](compatibility/#compatibility)
